----------------------------------------------------------------
-- Multiplication of polynomials mod f (MSEfirst.adb)
--
-- Most Significant Element(MSE)-First multiplier
-- 
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with finite_fields_ch5; use finite_fields_ch5;
with polynomials_ch5; use polynomials_ch5;

procedure MSEfirst is 
   A,B,F,C: Polynomial_m1;

begin
loop

   for i in 0 .. m-1 loop Put("A(");Put(i);Put(") = "); Get(A(i)); end loop; New_Line;
   for i in 0 .. m-1 loop Put("B(");Put(i);Put(") = "); Get(B(i)); end loop; New_Line;
   for i in 0 .. m-1 loop Put("F(");Put(i);Put(") = "); Get(F(i)); end loop; New_Line;

   for i in 0 .. m-1 loop C(i) := 0; end loop;

   for i in 0 .. m-1 loop
      C := addition_mod_f_poly(multiply_by_x_zp(C,F), product(A,B(m-1-i)));
   end loop;   

   Put("C = "); for i in 0 .. m-1 loop Put(C(i)); Put(","); end loop; New_Line; New_Line;

end loop;
end MSEfirst;