----------------------------------------------------------------
-- Exponentiation by Square and Multiply (OEF_exp.adb)
--
-- Using OEF multiplication primitives 
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with finite_fields_ch5; use finite_fields_ch5;
with polynomials_ch5; use polynomials_ch5;

procedure OEF_exp is 
   A,K: Polynomial_m1;
   B,D: Polynomial_m1;
   c: integer;

begin
loop

   for i in 0 .. m-1 loop Put("A(");Put(i);Put(") = "); Get(A(i)); end loop; New_Line;
   for i in 0 .. m-1 loop Put("K(");Put(i);Put(") = "); Get(K(i)); end loop; New_Line;
   Put("C = "); Get(c); New_Line;

   for i in 0 .. m-1 loop B(i) := 0; end loop;

   D := A;
   B(0) := 1;
   for i in 0 .. m-1 loop
      if K(i) = 1 then
         B := OEF_LSE_mult(B,D,c);
      end if;
      D := OEF_LSE_mult(D,D,c);
   end loop;   

   Put("B = "); for i in 0 .. m-1 loop Put(B(i)); Put(","); end loop; New_Line; New_Line;

end loop;
end OEF_exp;