----------------------------------------------------------------
-- Multiplication of OEF polynomials mod f (OEF_mult_mod_f.adb)
--
-- Classic algorithm for Optimal Extension Fields (OEF) 
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with finite_fields_ch5; use finite_fields_ch5;
with polynomials_ch5; use polynomials_ch5;

procedure OEF_mult_mod_f is 
   A,B,E: Polynomial_m1;
   D: Polynomial_m2;
   c: Integer;

begin
loop

   for i in 0 .. m-1 loop Put("A(");Put(i);Put(") = "); Get(A(i)); end loop; New_Line;
   for i in 0 .. m-1 loop Put("B(");Put(i);Put(") = "); Get(B(i)); end loop; New_Line;
   Put("C = "); Get(c); New_Line;

   D := poly_mult_zp(A,B);

   e(m-1) := d(m-1);    
   for i in 0 .. m-2 loop 
      e(i) := mod_m_addition(d(i),dar_mod_multiplication(d(m+i),c,p,m),p,m);
   end loop;
    
Put("E = "); for i in 0 .. m-1 loop Put(E(i)); Put(","); end loop; New_Line; New_Line;

end loop;
end OEF_mult_mod_f;
