----------------------------------------------------------------
-- Multiplication of polynomials mod f (multiplication_mod_f_poly.adb)
--
-- Two step multiplication
-- 
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with Finite_Fields_Ch5; use Finite_Fields_Ch5;
with Polynomials_Ch5; use Polynomials_Ch5;

procedure Multiplication_Mod_F_Poly is 
   A,B,F,C: Polynomial_M1;
   D: Polynomial_M2;
   R: Polynomial_Matrix_M1m2;

begin
   loop
      for I in 0 .. M-1 loop Put("A(");Put(I);Put(") = "); Get(A(I)); end loop; New_Line;
      for I in 0 .. M-1 loop Put("B(");Put(I);Put(") = "); Get(B(I)); end loop; New_Line;
      for I in 0 .. M-1 loop Put("F(");Put(I);Put(") = "); Get(F(I)); end loop; New_Line;

      D := Poly_Mult_Zp(A,B);
      R := Reduction_Matrix_R_Zp(F);
 
      for J in 0 .. M-1 loop 
         C(J) := D(J); 
      end loop;
    
      for J in 0 .. M-1 loop
         for I in 0 .. M-2 loop
            C(J) := Mod_M_Addition(C(J),Dar_Mod_Multiplication(R(J,I),D(M+I),P,M),P,M);
         end loop;
      end loop;

      Put("C = "); for I in 0 .. M-1 loop Put(C(I)); Put(","); end loop; New_Line; New_Line;

   end loop;
end Multiplication_Mod_F_Poly;
